require 'fwtoolkit/git_client'
require 'aruba/api'

Then /^the file named "([^"]*)" should have been committed to the repository at path "([^"]*)"$/ do |file, repo_path|
  repo = GitClient::Repository.new(File.join(current_dir, repo_path))
  status = repo.status
  if status == nil
    status.should be_nil
  else
    repo.status.values.any?{ |v| v.include?(file).should be_false }
  end
end

Then /^an initialized git repository should exists inside a directory named "([^"]*)"$/ do |repo_path|
  repo = GitClient::Repository.new(File.join(current_dir, repo_path))
  repo.initialized?
end

Given /^an initialized git repository inside a directory named "([^"]*)"$/ do |repo_path|
  repo = GitClient::Repository.new(File.join(current_dir, repo_path))
  repo.init
end

Given /^a valid \.gitignore file exists inside a directory named "([^"]*)"$/ do |repo_path|
  write_file File.join(repo_path, '.gitignore'), ".DB_Store\ntemp\ntmp"
end

Given /^the directory "([^"]*)" contains an uncommitted file named "([^"]*)"$/ do |repo_path, file_name|
  write_file File.join(repo_path, file_name), ".DB_Store\ntemp\ntmp"
end