require 'aruba/api'

module Aruba
  module Api
    # The original version installs bundle and doesn't check if the gemset is clean, so we can't use it
    alias_method :orig_use_clean_gemset, :use_clean_gemset unless method_defined?(:orig_use_clean_gemset)

    def use_clean_gemset(gemset)
      unset_bundler_env_vars
      #      orig_use_clean_gemset gemset
      run_simple(%{rvm gemset create "#{gemset}"}, true)
      if all_stdout =~ /'#{gemset}' gemset created \((.*)\)\./
        gem_home = $1
        set_env('GEM_HOME', gem_home)
        set_env('GEM_PATH', gem_home)
        set_env('BUNDLE_PATH', gem_home)

        paths = (ENV['PATH'] || "").split(File::PATH_SEPARATOR)
        paths.unshift(File.join(gem_home, 'bin'))
        set_env('PATH', paths.uniq.join(File::PATH_SEPARATOR))
      else
        raise "I didn't understand rvm's output: #{all_stdout}"
      end

      run_simple(%{rvm --force gemset empty "#{gemset}"}, true)
    end
  end
end
