Feature: Create new project
  As a lead developer
  I want to use fwt to create a new Xcode project
  So that the structure of the project is compliant with FW's standards

  Background: 
    Given a configured installation of FWToolkit for "Tom the Dev" working for "Awesome Company"

  @xcode
  Scenario: Create a new project
    When I successfully run `fwt xcode new objc MyProject AAA`
    Then I cd to "MyProject"
    And the following directories should exist:
      | MyProject.xcworkspace |
      | MyProject/MyProject.xcodeproj |
      | MyProject/MyProject/Resources/Assets.xcassets |
      | MyProject/MyProject/Resources/Assets.xcassets/AppIcon.appiconset |
      | MyProject/MyProject/Resources/Base.lproj |
    And the following files should exist:
      | MyProject/MyProject/AAAAppDelegate.h |
      | MyProject/MyProject/AAAAppDelegate.m |
      | MyProject/MyProject.entitlements |
      | MyProject/MyProject/Supporting Files/Info.plist |
      | MyProject/MyProject/Supporting Files/fw-shared.xcconfig |
      | MyProject/MyProject/Supporting Files/main.m |
      | MyProject/MyProjectTests/Resources/Info.plist |
      | MyProject/MyProjectTests/AAAMyProjectTests.m |
    And I successfully run `xcodebuild -scheme MyProject -workspace MyProject.xcworkspace -sdk iphonesimulator`
