require 'fwtoolkit/projectfile'
require 'support/project_generator'

describe "FWToolkit::Project" do
  
  class DummyClass
  end

  let!(:project) { ProjectGenerator.new }
  let(:project_folder) { project.project_folder }
  let(:project_class) { DummyClass.new }
  
  before(:each) do
    @project_class.extend FWToolkit::Projectfile
  end

  after(:each) do
    FileUtils.rm_rf(project_folder)
  end

  it "correctly parses a full projectfile" do
    project.create_test_project ProjectGenerator::PRJFILE_COMPLETE_CONFIG
    FWToolkit::Projectfile.load! project_folder
    FWToolkit::Projectfile.config.should == ProjectGenerator::PRJFILE_COMPLETE_CONFIG 
  end

  it "correctly adds defaults to an incomplete projectfile" do
    project.create_test_project ProjectGenerator::PRJFILE_STANDARD_CONFIG
    FWToolkit::Projectfile.load! project_folder
    FWToolkit::Projectfile.config.should == ProjectGenerator::PRJFILE_COMPLETE_CONFIG
  end

  it "raises an exception if the minimal config is not specified" do
    invalid_config = ProjectGenerator::PRJFILE_COMPLETE_CONFIG.clone
    invalid_config.delete(:project_name)

    project.create_test_project invalid_config
    expect { FWToolkit::Projectfile.load! project_folder }.to raise_error(NameError)
  end
end
